function ploteuclidgraphbi(G,X,part)
%disegna un grafo euclideo bipartito G, con nodi di coordinate date da X, nella retta, nel piano o nello spazio

newcolors = {  'red', 'blue', 'green', 'cyan', 'magenta'};
colororder(newcolors)


[len,m]=size(X);
E= G.Edges.EndNodes;

if iscell(E)
E= cellfun(@str2double, G.Edges.EndNodes);
end

[n,~]=size(E);

if m==1
   
    for j=1:n
        plot([X(E(j,1)),X(E(j,2))], [0.5,0.5], 'color',[0.5,0.5,0.5]);
        hold on
    end
    s=max(part);
    in=min(part);
    for j=in:s
        scatter(X( nonzeros((1:len)'.*(part==j))), 0.5*nonzeros(part==j))
        hold on
    end
    hold off
end

if m==2
   
    for j=1:n
        plot([X(E(j,1),1);X(E(j,2),1)], [X(E(j,1),2);X(E(j,2),2)],'color',[0.5,0.5,0.5] );
        hold on
    end
   s=max(part);
    in=min(part);
    for j=in:s
        plot(X( nonzeros((1:len)'.*(part==j)), 1), X(nonzeros((1:len)'.*(part==j)),2), 'o')
        hold on
    end
    hold off
end
if m==3
    
    for j=1:n
        plot3([X(E(j,1),1);X(E(j,2),1)], [X(E(j,1),2);X(E(j,2),2)], [X(E(j,1),3);X(E(j,2),3)],'color',[0.5,0.5,0.5] );
        hold on
    end
     s=max(part);
    in=min(part);
    for j=in:s
        plot3(X( nonzeros((1:len)'.*(part==j)),1), X( nonzeros((1:len)'.*(part==j)),2),X( nonzeros((1:len)'.*(part==j)),3), 'o')
        hold on
    end
    hold off
end

if m>3
    fprintf("Il grafo  in dimensione %i \n ", m)
end

