%confronta il tempo (medio)impiegato a calcolare un MST dati n punti in Rm 
%che formano un grafo euclideo utilizzando MSTJ, minspantree (algoritmo già 
%presente in Matlab)e le euristiche MSTeuh, MSTeuhbar e MSTeusort.

%numero massimo di nodi (x80)
n=100;
%numero di test per ogni numero di nodi
r=5;

%dimensione dello spazio in cui sono contenuti i nodi
m=2;

avtimeMSTJ=zeros(n,1);
avtimeeuh=zeros(n,1);
avtimeeuhbar=zeros(n,1);
avtimeeusort=zeros(n,1);
avtimematlab=zeros(n,1);
for k=n:-1:1
    
    timeMSTJ=zeros(r,1);
    timeeuh=zeros(r,1);
       timeeuhbar=zeros(r,1);
     timeeusort=zeros(r,1);
    timematlab=zeros(r,1);
    for s=1:r
        v=random('Uniform', 0, 1,[80*k,m]);
        tic
        MSTJ(v);
        timeMSTJ(s)=toc;
        tic
        MSTeuh(v);
        timeeuh(s)=toc;
          tic
        MSTeuhbar(v);
        timeeuhbar(s)=toc;
        tic
        MSTeusort(v);
        timeeusort(s)=toc;
        tic
        euclmatlabMST(v);
        timematlab(s)=toc;
    end
    
    avtimeMSTJ(k)=mean(timeMSTJ);
    avtimeeuh(k)=mean(timeeuh);
    avtimeeuhbar(k)=mean(timeeuhbar);
    avtimeeusort(k)=mean(timeeusort);
    avtimematlab(k)=mean(timematlab);
end

t=1:n;
t=80*t;

figure (1)
plot(t,avtimeMSTJ)
hold on
plot(t,avtimematlab)
hold on
plot(t,avtimeeuh)
hold on
plot(t,avtimeeuhbar)
hold on
plot(t,avtimeeusort)
legend("Jarnik Prim","Matlab","euh","euhbar", "eusort", 'Location', 'best')
xlabel('numero nodi')
ylabel('tempi')
hold off


%grafico in scala logaritmica
figure (2)
semilogy(t,avtimeMSTJ)
hold on
semilogy(t,avtimematlab)
hold on
semilogy(t,avtimeeuh)
hold on
semilogy(t,avtimeeuh)
hold on
semilogy(t,avtimeeusort)
legend("Jarnik Prim","Matlab","euh", "euhbar", "eusort", 'Location', 'best')
xlabel('numero nodi')
ylabel('tempi')
hold off

